var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { getCurrentScope, onScopeDispose, watch, unref, defineComponent, ref, getCurrentInstance, watchEffect, onMounted, isVue2, onUnmounted, h, nextTick } from "vue-demi";
function tryOnScopeDispose(fn) {
  if (getCurrentScope()) {
    onScopeDispose(fn);
    return true;
  }
  return false;
}
const isClient = typeof window !== "undefined";
const isString = (val) => typeof val === "string";
const noop = () => {
};
function unrefElement(elRef) {
  var _a2;
  const plain = unref(elRef);
  return (_a2 = plain == null ? void 0 : plain.$el) != null ? _a2 : plain;
}
const defaultWindow = isClient ? window : void 0;
isClient ? window.document : void 0;
isClient ? window.navigator : void 0;
isClient ? window.location : void 0;
function useEventListener(...args) {
  let target;
  let event;
  let listener;
  let options;
  if (isString(args[0])) {
    [event, listener, options] = args;
    target = defaultWindow;
  } else {
    [target, event, listener, options] = args;
  }
  if (!target)
    return noop;
  let cleanup = noop;
  const stopWatch = watch(() => unrefElement(target), (el) => {
    cleanup();
    if (!el)
      return;
    el.addEventListener(event, listener, options);
    cleanup = () => {
      el.removeEventListener(event, listener, options);
      cleanup = noop;
    };
  }, { immediate: true, flush: "post" });
  const stop = () => {
    stopWatch();
    cleanup();
  };
  tryOnScopeDispose(stop);
  return stop;
}
const _global = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
const globalKey = "__vueuse_ssr_handlers__";
_global[globalKey] = _global[globalKey] || {};
_global[globalKey];
var _a, _b;
isClient && (window == null ? void 0 : window.navigator) && ((_a = window == null ? void 0 : window.navigator) == null ? void 0 : _a.platform) && /iP(ad|hone|od)/.test((_b = window == null ? void 0 : window.navigator) == null ? void 0 : _b.platform);
var index$1 = "";
var VueLayoutPage = defineComponent({
  name: "VueLayoutPage",
  props: {
    hideHeaderPlaceholder: {
      type: Boolean,
      default: false
    },
    hideFooterPlaceholder: {
      type: Boolean,
      default: false
    },
    bodyBgColor: {
      type: String,
      default: ""
    }
  },
  setup(props, {
    slots
  }) {
    const h$1 = h;
    const header = ref();
    const footer = ref();
    const headerh = ref(0);
    const footerh = ref(0);
    const ev = window.onorientationchange ? "orientationchange" : "resize";
    console.log(getCurrentInstance());
    watchEffect(() => {
      document.body.style.backgroundColor = props.bodyBgColor;
    });
    const setHeaderHeight = () => {
      nextTick(() => {
        var _a2;
        headerh.value = ((_a2 = header.value) == null ? void 0 : _a2.offsetHeight) || 0;
      });
    };
    const setFooterHeight = () => {
      nextTick(() => {
        var _a2;
        footerh.value = ((_a2 = footer.value) == null ? void 0 : _a2.offsetHeight) || 0;
      });
    };
    const initPageLayout = () => {
      slots.footer ? setFooterHeight() : null;
      slots.header ? setHeaderHeight() : null;
    };
    onMounted(() => {
      if (isVue2) {
        header.value = document.querySelector(".layout-page-header");
        footer.value = document.querySelector(".layout-page-footer");
      }
      initPageLayout();
    });
    onUnmounted(() => {
      document.body.style.backgroundColor = "";
    });
    useEventListener(window, ev, () => {
      initPageLayout();
    });
    return () => {
      var _a2, _b2;
      return h$1("div", {
        "class": "vue-layout-page"
      }, [slots.header ? h$1("header", {
        "ref": header,
        "class": "layout-page-header"
      }, [(_a2 = slots.header) == null ? void 0 : _a2.call(slots)]) : null, slots.header && !props.hideHeaderPlaceholder ? h$1("div", {
        "style": {
          height: headerh.value + "px"
        }
      }, null) : null, slots.default ? h$1("main", {
        "class": "layout-page-main"
      }, [slots.default()]) : null, slots.footer && !props.hideFooterPlaceholder ? h$1("div", {
        "style": {
          height: footerh.value + "px"
        }
      }, null) : null, slots.footer ? h$1("footer", {
        "ref": footer,
        "class": "layout-page-footer"
      }, [(_b2 = slots.footer) == null ? void 0 : _b2.call(slots)]) : null]);
    };
  }
});
function defineComponentPlugin() {
  return __spreadValues({
    install: (app) => {
      app.component(VueLayoutPage.name, VueLayoutPage);
    }
  }, VueLayoutPage);
}
var index = defineComponentPlugin();
export { index as default };
